from __future__ import print_function
from qgis.core import *
from qgis.gui import *
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from utility.syncronizer import Syncronizer

class Choice(QDialog):

    def __init__(self, parent=None):
        super(Choice, self).__init__(parent)

        label = QLabel("Vuoi sincronizzare in dati con CdI_Tabelle.mdb?\n")
        infoLabel = QLabel("N.b.: L'operazione potrebbe portare alla rimozione di dati nel cdi_tabelle \n")
        buttonBox = QDialogButtonBox(QDialogButtonBox.Ok|QDialogButtonBox.Cancel)
        layout = QVBoxLayout()
        layout.addWidget(label)
        layout.addWidget(infoLabel)
        layout.addWidget(buttonBox)
        self.setLayout(layout)

        self.connect(buttonBox, SIGNAL("accepted()"), self, SLOT("accept()"))
        self.connect(buttonBox, SIGNAL("rejected()"), self, SLOT("reject()"))

        self.setWindowTitle("Sincronizza")


class Report(QDialog):

    def __init__(self, result, parent=None):
        super(Report, self).__init__(parent)

        self.result = result
        resultLabel = QLabel("<b>[WARNING] Sincronizzazione fallita</b>")
        buttonBox = QDialogButtonBox(QDialogButtonBox.Ok)

        layout = QVBoxLayout()
        layout.addWidget(resultLabel)

        if result:
            resultLabel.setText("<b>Sincronizzazione completata</b>")
            tLabel1 = QLabel("<br />Risultato tabella <i><b>\"Sito Puntuale\"</b></i>:")
            inLabel1 = QLabel("record inseriti: <b>{0}</b>".format(result["Sito_Puntuale"]["inserted"]))
            upLabel1 = QLabel("record aggiornati: <b>{0}</b>".format(result["Sito_Puntuale"]["updated"]))
            deLabel1 = QLabel("record eliminati: <b>{0}</b>".format(result["Sito_Puntuale"]["deleted"]))
            tLabel2 = QLabel("<br />Risultato tabella <i><b>\"Sito Lineare\"</b></i>:")
            inLabel2 = QLabel("record inseriti: <b>{0}</b>".format(result["Sito_Lineare"]["inserted"]))
            upLabel2 = QLabel("record aggiornati: <b>{0}</b>".format(result["Sito_Lineare"]["updated"]))
            deLabel2 = QLabel("record eliminati: <b>{0}</b>".format(result["Sito_Lineare"]["deleted"]))

            layout.addWidget(tLabel1)
            layout.addWidget(inLabel1)
            layout.addWidget(upLabel1)
            layout.addWidget(deLabel1)
            layout.addWidget(tLabel2)
            layout.addWidget(inLabel2)
            layout.addWidget(upLabel2)
            layout.addWidget(deLabel2)

        layout.addWidget(buttonBox)

        self.setLayout(layout)
        self.setWindowTitle("Risultato Sincronizzazione")

        self.connect(buttonBox, SIGNAL("accepted()"), self, SLOT("accept()"))


def syncronize():
    check = Choice()
    if check.exec_():
        sync = Syncronizer()
        results = Report(sync.run())
        results.exec_()
